package at.ac.uibk.gitsearch.domain;

import java.io.Serializable;
import javax.persistence.*;
import javax.validation.constraints.*;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A SavedSearches.
 */
@Entity
@Table(name = "saved_searches")
@Cache(usage = CacheConcurrencyStrategy.READ_WRITE)
@org.springframework.data.elasticsearch.annotations.Document(indexName = "savedsearches")
public class SavedSearches implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    @SuppressWarnings("PMD")
    private Long id;

    @NotNull
    @Size(max = 50)
    @Column(name = "name", length = 50, nullable = false)
    @SuppressWarnings("PMD")
    private String name;

    @NotNull
    @Size(max = 2000)
    @Column(name = "json_query", length = 2000, nullable = false)
    @SuppressWarnings("PMD")
    private String jsonQuery;

    @ManyToOne(optional = false)
    @NotNull
    @SuppressWarnings("PMD")
    private User user;

    // jhipster-needle-entity-add-field - JHipster will add fields here

    public Long getId() {
        return this.id;
    }

    @SuppressWarnings("PMD")
    public SavedSearches id(Long id) {
        this.setId(id);
        return this;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return this.name;
    }

    public SavedSearches name(String name) {
        this.setName(name);
        return this;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getJsonQuery() {
        return this.jsonQuery;
    }

    public SavedSearches jsonQuery(String jsonQuery) {
        this.setJsonQuery(jsonQuery);
        return this;
    }

    public void setJsonQuery(String jsonQuery) {
        this.jsonQuery = jsonQuery;
    }

    public User getUser() {
        return this.user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public SavedSearches user(User user) {
        this.setUser(user);
        return this;
    }

    // jhipster-needle-entity-add-getters-setters - JHipster will add getters and setters here

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof SavedSearches)) {
            return false;
        }
        return id != null && id.equals(((SavedSearches) o).id);
    }

    @Override
    public int hashCode() {
        // see https://vladmihalcea.com/how-to-implement-equals-and-hashcode-using-the-jpa-entity-identifier/
        return getClass().hashCode();
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "SavedSearches{" +
            "id=" + getId() +
            ", name='" + getName() + "'" +
            ", jsonQuery='" + getJsonQuery() + "'" +
            "}";
    }
}
