import { ComponentFixture, TestBed } from '@angular/core/testing';
import { HttpHeaders, HttpResponse } from '@angular/common/http';
import { HttpClientTestingModule } from '@angular/common/http/testing';
import { of } from 'rxjs';

import { ReviewHistoryEntryService } from '../service/review-history-entry.service';

import { ReviewHistoryEntryComponent } from './review-history-entry.component';

describe('ReviewHistoryEntry Management Component', () => {
  let comp: ReviewHistoryEntryComponent;
  let fixture: ComponentFixture<ReviewHistoryEntryComponent>;
  let service: ReviewHistoryEntryService;

  beforeEach(() => {
    TestBed.configureTestingModule({
      imports: [HttpClientTestingModule],
      declarations: [ReviewHistoryEntryComponent],
    })
      .overrideTemplate(ReviewHistoryEntryComponent, '')
      .compileComponents();

    fixture = TestBed.createComponent(ReviewHistoryEntryComponent);
    comp = fixture.componentInstance;
    service = TestBed.inject(ReviewHistoryEntryService);

    const headers = new HttpHeaders();
    jest.spyOn(service, 'query').mockReturnValue(
      of(
        new HttpResponse({
          body: [{ id: 123 }],
          headers,
        })
      )
    );
  });

  it('Should call load all on init', () => {
    // WHEN
    comp.ngOnInit();

    // THEN
    expect(service.query).toHaveBeenCalled();
    expect(comp.reviewHistoryEntries?.[0]).toEqual(expect.objectContaining({ id: 123 }));
  });
});
